import java_cup.runtime.*;

%%

%line
%column
%cup
%class Lexer

%%

if      {return new Symbol(sym.IF, yyline, yycolumn);}
else    {return new Symbol(sym.ELSE, yyline, yycolumn);}
[A-z][0-9A-z]*  {return new Symbol(sym.ID, yyline, yycolumn, yytext());}
[0-9]+  { int i = Integer.parseInt(yytext());
          return new Symbol(sym.NUMBER, yyline, yycolumn, new Integer(i));}
\{      {return new Symbol(sym.LBRACE, yyline, yycolumn);}
\}      {return new Symbol(sym.RBRACE, yyline, yycolumn);}
\+      {return new Symbol(sym.ADD, yyline, yycolumn);}
;       {return new Symbol(sym.SEMICOLON, yyline, yycolumn);}
=       {return new Symbol(sym.ASSIGN, yyline, yycolumn);}
.|\n    {}