    class Statement{
      static final int STAT     = 0;
      static final int IF_ELSE  = 1;
      static final int ASSIGN   = 2;
      static final int BLOCK    = 3;
      static final int STATSEQ  = 4;
      int type;

      static boolean similar(Statement s1,Statement s2){
        if (s1==null && s2==null) return true;
        if (s1==null || s2==null) return false;
        System.out.println("type "+s1.type+" = "+s2.type);
        if (s1.type != s2.type) return false;
        switch (s1.type) {
          case ASSIGN:
          case STAT: return true;
          case IF_ELSE: return
                          similar(((If)s1)._then,((If)s2)._then) &&
                          similar(((If)s1)._else,((If)s2)._else);
          case STATSEQ: return
                          similar(((StatSeq)s1)._first, ((StatSeq)s2)._first) &&
                          similar(((StatSeq)s1)._sequence, ((StatSeq)s2)._sequence);
        }
        return false;
      }
    }
    class If extends Statement{
      Expression _expr;
      Statement _then,_else;
      If(Expression e,Statement s1,Statement s2){
        type = IF_ELSE;
        _expr = e;
        _then = s1;
        _else = s2;
      }
    }
    class Assignment extends Statement{
      String _id;
      Expression _expr;
      Assignment(String id, Expression e){
        type = ASSIGN;
        _id = id;
        _expr = e;
      }
    }
    class StatSeq extends Statement{
      Statement _first, _sequence;
      StatSeq(Statement stat, Statement seq){
        type = STATSEQ;
        _first = stat;
        _sequence = seq;
      }
    }
    class Block extends Statement{
      StatSeq _sequence;
      Block(StatSeq seq){
        type = BLOCK;
        _sequence = seq;
      }
    }
    class Expression {
    }
